diff --git a/web/pgadmin/tools/sqleditor/static/js/components/dialogs/FilterDialog.jsx b/web/pgadmin/tools/sqleditor/static/js/components/dialogs/FilterDialog.jsx
new file mode 100644
index 000000000..336b47d31
--- /dev/null
+++ b/web/pgadmin/tools/sqleditor/static/js/components/dialogs/FilterDialog.jsx
@@ -0,0 +1,155 @@
+/////////////////////////////////////////////////////////////
+//
+// pgAdmin 4 - PostgreSQL Tools
+//
+// Copyright (C) 2013 - 2022, The pgAdmin Development Team
+// This software is released under the PostgreSQL Licence
+//
+//////////////////////////////////////////////////////////////
+import { makeStyles } from '@material-ui/core';
+import React from 'react';
+import SchemaView from '../../../../../../static/js/SchemaView';
+import BaseUISchema from '../../../../../../static/js/SchemaView/base_schema.ui';
+import gettext from 'sources/gettext';
+import { QueryToolContext } from '../QueryToolComponent';
+import url_for from 'sources/url_for';
+import PropTypes from 'prop-types';
+
+class SortingCollection extends BaseUISchema {
+  constructor(columnOptions) {
+    super({
+      name: undefined,
+      order: 'asc',
+    });
+    this.columnOptions = columnOptions;
+    this.reloadColOptions = 0;
+  }
+
+  setColumnOptions(columnOptions) {
+    this.columnOptions = columnOptions;
+    this.reloadColOptions = this.reloadColOptions + 1;
+  }
+
+  get baseFields() {
+    return [
+      {
+        id: 'name', label: gettext('Column'), cell: 'select', controlProps: {
+          allowClear: false,
+        }, noEmpty: true, options: this.columnOptions, optionsReloadBasis: this.reloadColOptions
+      },
+      {
+        id: 'order', label: gettext('Order'), cell: 'select', controlProps: {
+          allowClear: false,
+        }, options: [
+          {label: gettext('ASC'), value: 'asc'},
+          {label: gettext('DESC'), value: 'desc'},
+        ]
+      },
+    ];
+  }
+}
+
+class FilterSchema extends BaseUISchema {
+  constructor(columnOptions) {
+    super({
+      sql: null,
+      data_sorting: [],
+    });
+    this.sortingCollObj = new SortingCollection(columnOptions);
+  }
+
+  setColumnOptions(columnOptions) {
+    this.sortingCollObj.setColumnOptions(columnOptions);
+  }
+
+  get baseFields() {
+    let obj = this;
+    return [
+      {
+        id: 'sql', label: gettext('SQL Filter'), type: 'sql', controlProps: {
+          options: {
+            lineWrapping: true,
+          },
+        }
+      },
+      {
+        id: 'data_sorting', label: gettext('Data Sorting'), type: 'collection', schema: obj.sortingCollObj,
+        group: 'temp', uniqueCol: ['name'], canAdd: true, canEdit: false, canDelete: true,
+      },
+    ];
+  }
+}
+
+const useStyles = makeStyles((theme)=>({
+  root: {
+    ...theme.mixins.tabPanel,
+  },
+}));
+
+export default function FilterDialog({onClose, onSave}) {
+  const classes = useStyles();
+  const queryToolCtx = React.useContext(QueryToolContext);
+  const filterSchemaObj = React.useMemo(()=>new FilterSchema([]));
+
+  const getInitData = ()=>{
+    return new Promise((resolve, reject)=>{
+      const getFilterData = async ()=>{
+        try {
+          let {data: respData} = await queryToolCtx.api.get(url_for('sqleditor.get_filter_data', {
+            'trans_id': queryToolCtx.params.trans_id,
+          }));
+          let {column_list: columns, ...filterData} = respData.data.result;
+          filterSchemaObj.setColumnOptions((columns||[]).map((c)=>({label: c, value: c})));
+          resolve(filterData);
+        } catch (error) {
+          reject(error);
+        }
+      };
+      getFilterData();
+    });
+  };
+
+  const onSaveClick = (_isNew, changeData)=>{
+    return new Promise((resolve, reject)=>{
+      const setFilterData = async ()=>{
+        try {
+          let {data: respData} = await queryToolCtx.api.put(url_for('sqleditor.set_filter_data', {
+            'trans_id': queryToolCtx.params.trans_id,
+          }), changeData);
+          if(respData.data.status) {
+            resolve();
+            onSave();
+          } else {
+            reject(respData.data.result);
+          }
+        } catch (error) {
+          reject(error);
+        }
+      };
+      setFilterData();
+    });
+  };
+
+  return (<>
+    <SchemaView
+      formType={'dialog'}
+      getInitData={getInitData}
+      schema={filterSchemaObj}
+      viewHelperProps={{
+        mode: 'create',
+      }}
+      onSave={onSaveClick}
+      onClose={onClose}
+      hasSQL={false}
+      disableSqlHelp={true}
+      disableDialogHelp={true}
+      isTabView={false}
+      formClassName={classes.root}
+    />
+  </>);
+}
+
+FilterDialog.propTypes = {
+  onClose: PropTypes.func,
+  onSave: PropTypes.func,
+};
diff --git a/web/pgadmin/tools/sqleditor/static/js/components/dialogs/MacrosDialog.jsx b/web/pgadmin/tools/sqleditor/static/js/components/dialogs/MacrosDialog.jsx
new file mode 100644
index 000000000..f67e18899
--- /dev/null
+++ b/web/pgadmin/tools/sqleditor/static/js/components/dialogs/MacrosDialog.jsx
@@ -0,0 +1,189 @@
+/////////////////////////////////////////////////////////////
+//
+// pgAdmin 4 - PostgreSQL Tools
+//
+// Copyright (C) 2013 - 2022, The pgAdmin Development Team
+// This software is released under the PostgreSQL Licence
+//
+//////////////////////////////////////////////////////////////
+import { makeStyles } from '@material-ui/core';
+import React from 'react';
+import SchemaView from '../../../../../../static/js/SchemaView';
+import BaseUISchema from '../../../../../../static/js/SchemaView/base_schema.ui';
+import gettext from 'sources/gettext';
+import { QueryToolContext } from '../QueryToolComponent';
+import url_for from 'sources/url_for';
+import _ from 'lodash';
+import PropTypes from 'prop-types';
+
+class MacrosCollection extends BaseUISchema {
+  constructor(keyOptions) {
+    super();
+    this.keyOptions = keyOptions;
+  }
+
+  get idAttribute() {
+    return 'mid';
+  }
+
+  get baseFields() {
+    let obj = this;
+    return [
+      {
+        id: 'id', label: gettext('Key'), cell: 'select', noEmpty: true,
+        width: 100, options: obj.keyOptions, optionsReloadBasis: obj.keyOptions.length,
+        controlProps: {
+          allowClear: false,
+        }
+      },
+      {
+        id: 'name', label: gettext('Name'), cell: 'text', noEmpty: true,
+        width: 100,
+      },
+      {
+        id: 'sql', label: gettext('SQL'), cell: 'sql', noEmpty: true,
+        width: 300, controlProps: {
+          options: {
+            foldGutter: false,
+            lineNumbers: false,
+            gutters: [],
+            readOnly: true,
+            lineWrapping: true,
+          },
+        }
+      },
+    ];
+  }
+}
+
+class MacrosSchema extends BaseUISchema {
+  constructor(keyOptions) {
+    super();
+    this.macrosCollObj = new MacrosCollection(keyOptions);
+  }
+
+  get baseFields() {
+    let obj = this;
+    return [
+      {
+        id: 'macro', label: '', type: 'collection', schema: obj.macrosCollObj,
+        canAdd: true, canDelete: true, isFullTab: true, group: 'temp',
+      },
+    ];
+  }
+
+  validate(state, setError) {
+    let allKeys = state.macro.map((m)=>m.id.toString());
+    if(allKeys.length !=  new Set(allKeys).size) {
+      setError('macro', gettext('Key must be unique.'));
+      return true;
+    }
+    return false;
+  }
+}
+
+const useStyles = makeStyles((theme)=>({
+  root: {
+    ...theme.mixins.tabPanel,
+    padding: 0,
+  },
+}));
+
+function getChangedMacros(macrosData, changeData) {
+  /* For backend, added, removed is changed. Convert all added, removed to changed. */
+  let changed = [];
+  for (const m of (changeData.macro.changed || [])) {
+    let newM = {...m};
+    if('id' in m) {
+      /* if key changed, clear prev and add new */
+      changed.push({id: m.mid, name: null, sql: null});
+      let em = _.find(macrosData, (d)=>d.mid==m.mid);
+      newM = {name: em.name, sql: em.sql, ...m};
+    } else {
+      newM.id = m.mid;
+    }
+    delete newM.mid;
+    changed.push(newM);
+  }
+  for (const m of (changeData.macro.deleted || [])) {
+    changed.push({id: m.id, name: null, sql: null});
+  }
+  for (const m of (changeData.macro.added || [])) {
+    changed.push(m);
+  }
+  return changed;
+}
+
+export default function MacrosDialog({onClose, onSave}) {
+  const classes = useStyles();
+  const queryToolCtx = React.useContext(QueryToolContext);
+  const [macrosData, setMacrosData] = React.useState([]);
+  const [macrosErr, setMacrosErr] = React.useState(null);
+
+  React.useEffect(async ()=>{
+    try {
+      let {data: respData} = await queryToolCtx.api.get(url_for('sqleditor.get_macros', {
+        'trans_id': queryToolCtx.params.trans_id,
+      }));
+      /* Copying id to mid to track key id changes */
+      setMacrosData(respData.macro.map((m)=>({...m, mid: m.id})));
+    } catch (error) {
+      setMacrosErr(error);
+    }
+  }, []);
+
+  const onSaveClick = (_isNew, changeData)=>{
+    return new Promise((resolve, reject)=>{
+      const setMacros = async ()=>{
+        try {
+          let changed = getChangedMacros(macrosData, changeData);
+          let {data: respData} = await queryToolCtx.api.put(url_for('sqleditor.set_macros', {
+            'trans_id': queryToolCtx.params.trans_id,
+          }), {changed: changed});
+          resolve();
+          onSave(respData.macro?.filter((m)=>Boolean(m.name)));
+          onClose();
+        } catch (error) {
+          reject(error);
+        }
+      };
+      setMacros();
+    });
+  };
+
+  const keyOptions = macrosData.map((m)=>({
+    label: m.key_label,
+    value: m.id,
+  }));
+
+  if(keyOptions.length <= 0) {
+    return <></>;
+  }
+  return (<>
+    <SchemaView
+      formType={'dialog'}
+      getInitData={()=>{
+        if(macrosErr) {
+          return Promise.reject(macrosErr);
+        }
+        return Promise.resolve({macro: macrosData.filter((m)=>Boolean(m.name))});
+      }}
+      schema={new MacrosSchema(keyOptions)}
+      viewHelperProps={{
+        mode: 'edit',
+      }}
+      onSave={onSaveClick}
+      onClose={onClose}
+      hasSQL={false}
+      disableSqlHelp={true}
+      disableDialogHelp={true}
+      isTabView={false}
+      formClassName={classes.root}
+    />
+  </>);
+}
+
+MacrosDialog.propTypes = {
+  onClose: PropTypes.func,
+  onSave: PropTypes.func,
+};
diff --git a/web/pgadmin/tools/sqleditor/static/js/components/dialogs/NewConnectionDialog.jsx b/web/pgadmin/tools/sqleditor/static/js/components/dialogs/NewConnectionDialog.jsx
new file mode 100644
index 000000000..fc35c0964
--- /dev/null
+++ b/web/pgadmin/tools/sqleditor/static/js/components/dialogs/NewConnectionDialog.jsx
@@ -0,0 +1,254 @@
+/////////////////////////////////////////////////////////////
+//
+// pgAdmin 4 - PostgreSQL Tools
+//
+// Copyright (C) 2013 - 2022, The pgAdmin Development Team
+// This software is released under the PostgreSQL Licence
+//
+//////////////////////////////////////////////////////////////
+import { makeStyles } from '@material-ui/core';
+import React, { useState } from 'react';
+import SchemaView from '../../../../../../static/js/SchemaView';
+import BaseUISchema from '../../../../../../static/js/SchemaView/base_schema.ui';
+import gettext from 'sources/gettext';
+import { QueryToolContext } from '../QueryToolComponent';
+import url_for from 'sources/url_for';
+import _ from 'lodash';
+import { flattenSelectOptions } from '../../../../../../static/js/components/FormComponents';
+import PropTypes from 'prop-types';
+import ConnectServerContent from '../../../../../../browser/static/js/ConnectServerContent';
+
+class NewConnectionSchema extends BaseUISchema {
+  constructor(api, params, connectServer) {
+    super({
+      sid: null,
+      did: null,
+      user: null,
+      role: null,
+      server_name: null,
+      database_name: null,
+    });
+    this.flatServers = [];
+    this.groupedServers = [];
+    this.dbs = [];
+    this.params = params;
+    this.api = api;
+    this.warningText = gettext('By changing the connection you will lose all your unsaved data for the current connection. <br> Do you want to continue?');
+    this.connectServer = connectServer;
+  }
+
+  setServerConnected(sid, icon) {
+    for(const group of this.groupedServers) {
+      for(const opt of group.options) {
+        if(opt.value == sid) {
+          opt.connected = true;
+          opt.image = icon || 'icon-pg';
+          break;
+        }
+      }
+    }
+  }
+
+  isServerConnected(sid) {
+    return _.find(this.flatServers, (s)=>s.value==sid)?.connected;
+  }
+
+  getServerList() {
+    let obj = this;
+    if(this.groupedServers?.length != 0) {
+      return Promise.resolve(this.groupedServers);
+    }
+    return new Promise((resolve, reject)=>{
+      this.api.get(url_for('sqleditor.get_new_connection_servers'))
+        .then(({data: respData})=>{
+          let groupedOptions = [];
+          _.forIn(respData.data.result.server_list, (v, k)=>{
+            /* initial selection */
+            _.find(v, (o)=>o.value==obj.params.sid).selected = true;
+            groupedOptions.push({
+              label: k,
+              options: v,
+            });
+          });
+          /* Will be re-used for changing icon when connected */
+          this.groupedServers = groupedOptions.map((group)=>{
+            return {
+              label: group.label,
+              options: group.options.map((o)=>({...o, selected: false})),
+            };
+          });
+          resolve(groupedOptions);
+        })
+        .catch((error)=>{
+          reject(error);
+        });
+    });
+  }
+
+  getOtherOptions(sid, type) {
+    if(!sid) {
+      return [];
+    }
+
+    if(!this.isServerConnected(sid)) {
+      return [];
+    }
+    return new Promise((resolve, reject)=>{
+      this.api.get(url_for(`sqleditor.${type}`, {
+        'sid': sid,
+        'sgid': 0,
+      }))
+        .then(({data: respData})=>{
+          resolve(respData.data.result.data);
+        })
+        .catch((error)=>{
+          reject(error);
+        });
+    });
+  }
+
+  get baseFields() {
+    let self = this;
+    return [
+      {
+        id: 'sid', label: gettext('Server'), type: 'select', noEmpty: true,
+        controlProps: {
+          allowClear: false,
+        }, options: ()=>this.getServerList(),
+        optionsLoaded: (res)=>this.flatServers=flattenSelectOptions(res),
+        optionsReloadBasis: this.flatServers.map((s)=>s.connected).join(''),
+        depChange: (state)=>{
+          /* Once the option is selected get the name */
+          /* Force sid to null, and set only if connected */
+          return {
+            server_name: _.find(this.flatServers, (s)=>s.value==state.sid)?.label,
+            did: null,
+            user: null,
+            role: null,
+            sid: null,
+          };
+        },
+        deferredDepChange: (state, source, topState, actionObj)=>{
+          return new Promise((resolve)=>{
+            let sid = actionObj.value;
+            if(!_.find(this.flatServers, (s)=>s.value==sid)?.connected) {
+              this.connectServer(sid, state.user, null, (data)=>{
+                self.setServerConnected(sid, data.icon);
+                resolve(()=>({sid: sid}));
+              });
+            } else {
+              resolve(()=>({sid: sid}));
+            }
+          });
+        },
+      }, {
+        id: 'did', label: gettext('Database'), deps: ['sid'], noEmpty: true,
+        controlProps: {
+          allowClear: false,
+        },
+        type: (state)=>({
+          type: 'select',
+          options: ()=>this.getOtherOptions(state.sid, 'get_new_connection_database'),
+          optionsReloadBasis: `${state.sid} ${this.isServerConnected(state.sid)}`,
+        }),
+        optionsLoaded: (res)=>this.dbs=res,
+        depChange: (state)=>{
+          /* Once the option is selected get the name */
+          return {database_name: _.find(this.dbs, (s)=>s.value==state.did)?.label};
+        }
+      },{
+        id: 'user', label: gettext('User'), deps: ['sid'], noEmpty: true,
+        controlProps: {
+          allowClear: false,
+        },
+        type: (state)=>({
+          type: 'select',
+          options: ()=>this.getOtherOptions(state.sid, 'get_new_connection_user'),
+          optionsReloadBasis: `${state.sid} ${this.isServerConnected(state.sid)}`,
+        }),
+      },{
+        id: 'role', label: gettext('Role'), deps: ['sid'],
+        type: (state)=>({
+          type: 'select',
+          options: ()=>this.getOtherOptions(state.sid, 'get_new_connection_role'),
+          optionsReloadBasis: `${state.sid} ${this.isServerConnected(state.sid)}`,
+        }),
+      },{
+        id: 'server_name', label: '', type: 'text', visible: false,
+      },{
+        id: 'database_name', label: '', type: 'text', visible: false,
+      },
+    ];
+  }
+}
+
+
+const useStyles = makeStyles((theme)=>({
+  root: {
+    ...theme.mixins.tabPanel,
+  },
+}));
+
+export default function NewConnectionDialog({onClose, onSave}) {
+  const classes = useStyles();
+  const [connecting, setConnecting] = useState(false);
+  const queryToolCtx = React.useContext(QueryToolContext);
+
+  const connectServer = async (sid, user, formData, connectCallback) => {
+    setConnecting(true);
+    try {
+      let {data: respData} = await queryToolCtx.api({
+        method: 'POST',
+        url: url_for('sqleditor.connect_server', {
+          'sid': sid,
+          ...(user ? {
+            'usr': user,
+          }:{}),
+        }),
+        headers: { 'Content-Type': 'application/x-www-form-urlencoded' },
+        data: formData
+      });
+      setConnecting(false);
+      connectCallback?.(respData.data);
+    } catch (error) {
+      queryToolCtx.modal.showModal(gettext('Connect to server'), (closeModal)=>{
+        return (
+          <ConnectServerContent
+            closeModal={()=>{
+              setConnecting(false);
+              closeModal();
+            }}
+            data={error.response?.data?.result}
+            onOK={(formData)=>{
+              connectServer(sid, null, formData, connectCallback);
+            }}
+          />
+        );
+      });
+    }
+  };
+
+  return <SchemaView
+    formType={'dialog'}
+    getInitData={()=>Promise.resolve({})}
+    schema={new NewConnectionSchema(queryToolCtx.api, {
+      sid: queryToolCtx.params.sid, sgid: 0,
+    }, connectServer)}
+    viewHelperProps={{
+      mode: 'create',
+    }}
+    loadingText={connecting ? 'Connecting...' : ''}
+    onSave={onSave}
+    onClose={onClose}
+    hasSQL={false}
+    disableSqlHelp={true}
+    disableDialogHelp={true}
+    isTabView={false}
+    formClassName={classes.root}
+  />;
+}
+
+NewConnectionDialog.propTypes = {
+  onClose: PropTypes.func,
+  onSave: PropTypes.func,
+};
diff --git a/web/pgadmin/tools/sqleditor/static/js/components/sections/ConnectionBar.jsx b/web/pgadmin/tools/sqleditor/static/js/components/sections/ConnectionBar.jsx
new file mode 100644
index 000000000..da1493e69
--- /dev/null
+++ b/web/pgadmin/tools/sqleditor/static/js/components/sections/ConnectionBar.jsx
@@ -0,0 +1,148 @@
+/////////////////////////////////////////////////////////////
+//
+// pgAdmin 4 - PostgreSQL Tools
+//
+// Copyright (C) 2013 - 2022, The pgAdmin Development Team
+// This software is released under the PostgreSQL Licence
+//
+//////////////////////////////////////////////////////////////
+import React from 'react';
+import { makeStyles } from '@material-ui/styles';
+import { Box, CircularProgress, Tooltip } from '@material-ui/core';
+import { DefaultButton, PgButtonGroup, PgIconButton } from '../../../../../../static/js/components/Buttons';
+import KeyboardArrowDownIcon from '@material-ui/icons/KeyboardArrowDown';
+import { ConnectedIcon, DisonnectedIcon, QueryToolIcon } from '../../../../../../static/js/components/ExternalIcon';
+import { QueryToolContext } from '../QueryToolComponent';
+import { CONNECTION_STATUS, CONNECTION_STATUS_MESSAGE } from '../QueryToolConstants';
+import HourglassEmptyRoundedIcon from '@material-ui/icons/HourglassEmptyRounded';
+import QueryBuilderRoundedIcon from '@material-ui/icons/QueryBuilderRounded';
+import ErrorOutlineRoundedIcon from '@material-ui/icons/ErrorOutlineRounded';
+import ReportProblemRoundedIcon from '@material-ui/icons/ReportProblemRounded';
+import { PgMenu, PgMenuItem } from '../../../../../../static/js/components/Menu';
+import gettext from 'sources/gettext';
+import RotateLeftRoundedIcon from '@material-ui/icons/RotateLeftRounded';
+import PropTypes from 'prop-types';
+
+const useStyles = makeStyles((theme)=>({
+  root: {
+    padding: '2px 4px',
+    display: 'flex',
+    alignItems: 'center',
+    gap: '4px',
+    backgroundColor: theme.otherVars.editorToolbarBg,
+  },
+  connectionButton: {
+    display: 'flex',
+    width: '450px',
+    backgroundColor: theme.palette.default.main,
+    color: theme.palette.default.contrastText,
+    border: '1px solid ' + theme.palette.default.borderColor,
+    justifyContent: 'flex-start',
+  },
+  viewDataConnTitle: {
+    marginTop: 'auto',
+    marginBottom: 'auto',
+    padding: '0px 4px',
+  },
+  menu: {
+    '& .szh-menu': {
+      minWidth: '450px',
+    }
+  }
+}));
+
+function ConnectionStatusIcon({connected, connecting, status}) {
+  if(connecting) {
+    return <CircularProgress style={{height: '18px', width: '18px'}} />;
+  } else if(connected) {
+    switch (status) {
+    case CONNECTION_STATUS.TRANSACTION_STATUS_ACTIVE:
+      return <HourglassEmptyRoundedIcon />;
+    case CONNECTION_STATUS.TRANSACTION_STATUS_INTRANS:
+      return <QueryBuilderRoundedIcon />;
+    case CONNECTION_STATUS.TRANSACTION_STATUS_INERROR:
+      return <ErrorOutlineRoundedIcon />;
+    case CONNECTION_STATUS.TRANSACTION_STATUS_UNKNOWN:
+      return <ReportProblemRoundedIcon />;
+    default:
+      return <ConnectedIcon />;
+    }
+  } else {
+    return <DisonnectedIcon />;
+  }
+}
+
+ConnectionStatusIcon.propTypes = {
+  connected: PropTypes.bool,
+  connecting: PropTypes.bool,
+  status: PropTypes.oneOf(Object.values(CONNECTION_STATUS)),
+};
+
+export function ConnectionBar({connected, connecting, connectionStatus, connectionStatusMsg,
+  connectionList, onConnectionChange, onNewConnClick, onNewQueryToolClick, onResetLayout}) {
+  const classes = useStyles();
+  const connMenuRef = React.useRef();
+  const [connDropdownOpen, setConnDropdownOpen] = React.useState(false);
+  const queryToolCtx = React.useContext(QueryToolContext);
+  const onConnItemClick = (e)=>{
+    if(!e.value.is_selected) {
+      onConnectionChange(e.value);
+    }
+    e.keepOpen = false;
+  };
+
+  const connTitle = React.useMemo(()=>_.find(connectionList, (c)=>c.is_selected)?.conn_title, [connectionList]);
+  return (
+    <>
+      <Box className={classes.root}>
+        <PgButtonGroup size="small">
+          {queryToolCtx.preferences?.sqleditor?.connection_status &&
+          <PgIconButton title={CONNECTION_STATUS_MESSAGE[connected ? connectionStatus : -1] ?? connectionStatusMsg}
+            icon={<ConnectionStatusIcon connecting={connecting} status={connectionStatus} connected={connected}/>}
+          />}
+          <DefaultButton className={classes.connectionButton} ref={connMenuRef}
+            onClick={queryToolCtx.params.is_query_tool ? ()=>setConnDropdownOpen(true) : undefined}
+            style={{backgroundColor: queryToolCtx.params.bgcolor, color: queryToolCtx.params.fgcolor}}
+          >
+            <Tooltip title={queryToolCtx.params.is_query_tool ? '' : connTitle}>
+              <Box display="flex" width="100%">
+                <Box textOverflow="ellipsis" overflow="hidden" marginRight="auto">{connecting && '(Obtaining connection)'}{connTitle}</Box>
+                {queryToolCtx.params.is_query_tool && <Box><KeyboardArrowDownIcon /></Box>}
+              </Box>
+            </Tooltip>
+          </DefaultButton>
+          <PgIconButton title="New query tool" icon={<QueryToolIcon />} onClick={onNewQueryToolClick}/>
+        </PgButtonGroup>
+        <PgButtonGroup size="small" variant="text" style={{marginLeft: 'auto'}}>
+          <PgIconButton title="Reset layout" icon={<RotateLeftRoundedIcon />} onClick={onResetLayout}/>
+        </PgButtonGroup>
+      </Box>
+      <PgMenu
+        anchorRef={connMenuRef}
+        open={connDropdownOpen}
+        onClose={()=>{setConnDropdownOpen(false);}}
+        className={classes.menu}
+      >
+        {(connectionList||[]).map((conn)=>{
+          return (
+            <PgMenuItem key={conn.conn_title} hasCheck checked={conn.is_selected} value={conn}
+              onClick={onConnItemClick}>{conn.conn_title}</PgMenuItem>
+          );
+        })}
+        <PgMenuItem onClick={onNewConnClick}>{`< ${gettext('New connection...')} >`}</PgMenuItem>
+      </PgMenu>
+    </>
+  );
+}
+
+ConnectionBar.propTypes = {
+  connected: PropTypes.bool,
+  connecting: PropTypes.bool,
+  connectionStatus: PropTypes.oneOf(Object.values(CONNECTION_STATUS)),
+  connectionStatusMsg: PropTypes.string,
+  connectionList: PropTypes.array,
+  onConnectionChange: PropTypes.func,
+  onNewConnClick: PropTypes.func,
+  onNewQueryToolClick: PropTypes.func,
+  onResetLayout: PropTypes.func,
+};
